//  mojIf
//  Based on mojIf API Spec. Ver. 1.21
//
//  Created by 冨永 裕太 on 2014/04/14.
//  Copyright (c) 2014年 Panasonic Corporation. All rights reserved.

"use strict"


try {
  
  //  mojIf オブジェクト定義
  window.mojIf = {};
  
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  //
  //  MOJ public const property
  //
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  
  // common argument : bool value
  mojIf.BOOL_TRUE  = 1;
  mojIf.BOOL_FALSE = 0;
    
  //  method callback argument : result property
  mojIf.RESULT_SUCCESS  = "success";
  mojIf.RESULT_ERROR    = "error";
  

  //  method callback argument : reason property
  mojIf.REASON_SCRIPT   = "2000000001";         //  Script system error.
  
  //  method callback argument : device connecting status property
  mojIf.STATUS_DISCONNECT      = "disconnect";     // Not connected with Device.
  mojIf.STATUS_CONNECTED_HOME  = "connected_home"; // Connected with Device at Home.
  mojIf.STATUS_CONNECTING_INET = "connecting_p2p"; // Try to Connect with Device at Outdoor.
  mojIf.STATUS_CONNECTED_INET  = "connected_inet"; // Connected with Device at Outdoor.
  
  // mothod input argument : screen type
  mojIf.SCREEN_SETTING         = "setting";    // Settings
  mojIf.SCREEN_DEV_SELECT      = "dev_select"; // Device Select
  mojIf.SCREEN_DEV_REGIST      = "dev_regist"; // Device Settings
  mojIf.SCREEN_DEV_DETAIL      = "dev_detail"; // Device Settings (detail)
  mojIf.SCREEN_LOGIN_INDUCTION = "induction";  // Login Induction
  mojIf.SCREEN_EULA            = "eula";       // EULA
  mojIf.SCREEN_P2P_CHECK       = "p2p_check";  // P2P Check

  //  method input argument : key type
  mojIf.KEY_TYPE_BACK = 0x00000001;         //  BackKey
  
  //  method input argument : content capability
  mojIf.CONTENT_CAP_REMOTE_VIEW = 0x00000001;  // Remote View
    
  // method input argument : ctrl type
  mojIf.CTRL_TYPE_PLAY_RENDERER = 0x00000001;  // Play on renderer.
  mojIf.CTRL_TYPE_ADD_TEMP_LIST = 0x00000002;  // Add to temporary list.

  // method input argument : content management type
  mojIf.CONTENT_MNG_TYPE_NORMAL    = "normal"; // normal content
  mojIf.CONTENT_MNG_TYPE_TEMP_LIST = "temp";   // temporary list content

  // method input argument : renderer capability
  mojIf.RENDERER_CAP_PAUSE     = 0x00000001;  // Enable pause on Renderer.
  mojIf.RENDERER_CAP_SEEK      = 0x00000002;  // Enable seek on Renderer.
  mojIf.RENDERER_CAP_SKIP      = 0x00000004;  // Enable skip on Renderer.
  mojIf.RENDERER_CAP_VOL       = 0x00000008;  // Enable volume control on Renderer.
  mojIf.RENDERER_CAP_UPRESUME  = 0x00000010;  // Enable update resume from Renderer.

  //  method callback argument : renderer play state
  
  mojIf.RENDERER_STATE_STOPPED = "stopped"; // Renderer stop state.
  mojIf.RENDERER_STATE_PLAYING = "playing"; // Renderer playing state.
  mojIf.RENDERER_STATE_PAUSED  = "paused";  // Renderer paused state.
  
  // method input argument : mute
  mojIf.MUTE_ON  = "on";  // mute is on.
  mojIf.MUTE_OFF = "off"; // mute is off.
  
  // method input argument : skip direction
  mojIf.SKIP_FORWARD  = "forward";  // skip forward
  mojIf.SKIP_BACKWARD = "backward"; // skip backward
  
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  //
  //  MOJ public methods
  //
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  mojIf.appInit = function() {};
  mojIf.appExit = function() {};

  mojIf.init = function() {
    return mojIf.callNative( "appInit" );
  };
  
  mojIf.exit = function( logout ) {
    var inputParams = { "logout": logout };
    return mojIf.callNative( "appExit", inputParams );
  };
  
  mojIf.reloadWithNewOnetimekey = function() {
    return mojIf.callNative( "reloadWithNewOnetimekey" );
  };
  
  mojIf.getStatus = function( deviceId16 ) {
    var inputParams = { "deviceId16": deviceId16 };
    return mojIf.callNative( "getStatus", inputParams );
  };

  mojIf.watchStatus = function( deviceId16, status ) {
    var inputParams = { "deviceId16": deviceId16,
              "status" : status };
    return mojIf.callNative( "watchStatus", inputParams );
  };
  
  mojIf.getDeviceInfo = function( deviceId16, infoKey ) {
    var inputParams = { "deviceId16": deviceId16,
            "infoKey" : infoKey };
    return mojIf.callNative( "getDeviceInfo", inputParams );
  };
    
  mojIf.getThumbnailUrl = function( getThumbnailUrlParams ) {
    return mojIf.callNative( "getThumbnailUrl", getThumbnailUrlParams );
  };

  mojIf.cancelGetThumbnailUrl = function() {
    return mojIf.callNative( "cancelGetThumbnailUrl" );
  };

  mojIf.startPlayer = function( startPlayerParams ) {
    return mojIf.callNative( "startPlayer", startPlayerParams );
  };

  mojIf.showScreen = function( screenType, deviceId16 ) {
    var inputParams = { "screenType": screenType,
                        "deviceId16": deviceId16 };
    return mojIf.callNative( "showScreen", inputParams );
  };
    
  mojIf.openWebBrowserApp = function( url ) {
    var inputParams = { "url": url };
    return mojIf.callNative( "openWebBrowserApp", inputParams );
  };

  mojIf.watchKeyEvent = function( keyType ) {
    var inputParams = { "keyType": keyType };
    return mojIf.callNative( "watchKeyEvent", inputParams );
  };

  mojIf.cancelWatchKeyEvent = function( keyType ) {
    var inputParams = { "keyType": keyType };
    return mojIf.callNative( "cancelWatchKeyEvent", inputParams );
  };

  mojIf.startDrag = function( startDragParams ) {
    return mojIf.callNative( "startDrag", startDragParams );
  };

  mojIf.getRendererDevice = function() {
    return mojIf.callNative( "getRendererDevice" );
  };

  mojIf.startRenderer = function( startRendererParams ) {
    return mojIf.callNative( "startRenderer", startRendererParams );
  };

  mojIf.playRenderer = function() {
    return mojIf.callNative( "playRenderer" );
  };

  mojIf.pauseRenderer = function() {
    return mojIf.callNative( "pauseRenderer" );
  };

  mojIf.stopRenderer = function() {
    return mojIf.callNative( "stopRenderer" );
  };

  mojIf.skipRenderer = function( direction ) {
    var inputParams = { "direction": direction };
    return mojIf.callNative( "skipRenderer", inputParams );
  };
    
  mojIf.seekRenderer = function( seekPoint ) {
    var inputParams = { "seekPoint": seekPoint };
    return mojIf.callNative( "seekRenderer", inputParams );
  };

  mojIf.setRendererVolume = function( volume ) {
    var inputParams = { "volume": volume };
    return mojIf.callNative( "setRendererVolume", inputParams );
  };

  mojIf.setRendererMute = function( mute ) {
    var inputParams = { "mute": mute };
    return mojIf.callNative( "setRendererMute", inputParams );
  };

  mojIf.getRendererInfo = function() {
    return mojIf.callNative( "getRendererInfo" );
  };

  mojIf.finishRenderer = function() {
    return mojIf.callNative( "finishRenderer" );
  };

  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  //
  //  MOJ private methods
  //
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  
  //  Nativeインターフェース
  mojIf.callNative = function( methodName, inputParam ) {
   // 引数チェック
    if (methodName == null) {
     var errStr = "Error: Invalid arguments. [" + methodName + "]";
      mojIf.dbgLog( errStr );
      throw new Error( errStr );
    }
    
    var pathName = "mojIf." + methodName;
    
      mojIf.dbgLog(pathName);
    
    //  コールバック生成
    var callbackName = pathName + ".onCallback";
    eval( callbackName + "= function( e ) { mojIf.dbgLog('empty callback!'); };" );
    
    //  Nativeに渡すパラメータ作成
    
    if (inputParam == null) {
      inputParam = {};
    }
    var inputObj = inputParam;
    inputObj._className  = "mojIf";
    inputObj._methodName = methodName;
    if (window.name == "") {
      inputObj._outputFunc = callbackName;
    } else {
      inputObj._outputFunc = window.name + "." + callbackName;
    }
    
    try {
      
      mojIf.dbgLog( "Call API: " + pathName + "(" + JSON.stringify( inputParam ) + ")" );
      
      var apiInfoStringWithURLEscaped = encodeURIComponent(JSON.stringify( inputObj ));
      var url = "mojIf:" + apiInfoStringWithURLEscaped;
      mojIf.dbgLog( "Converted URL: " + url );
      
    } catch( e ) {
      mojIf.dbgLog( "Error: Caught error! " + e );
      setTimeout( callbackName + "({result:'" + mojIf.RESULT_ERROR + "',reason:'" +  + mojIf.REASON_SCRIPT + "'});", 0 );
    }
    
    if (navigator.appVersion.indexOf( "Windows" ) >= 0 || navigator.appVersion.indexOf( "Macintosh" ) >= 0) {
      //  Windows/Mac Test code.
      setTimeout( callbackName + "({result:'" + mojIf.RESULT_ERROR + "',reason:'" + mojIf.REASON_SCRIPT + "'});", 0 );
    } else {
      setTimeout( function() { mojIf.callUrlScheme( url ); }, 0 );
    }
    
    return eval( pathName );
  };
  
  mojIf.callUrlScheme = function( url ) {
    //  mojIf.dbgLog( url );
    //  document.location = url;
    
    //  連続コールが無視されないよう document.location による直接遷移の代わりにダミーのフレームを作ってコール
    var iframe = document.createElement( "iframe" );
    iframe.setAttribute( "src", url );
    document.documentElement.appendChild( iframe );
    iframe.parentNode.removeChild( iframe );
    iframe = null;
  };
  
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  //
  //  デバッグログ出力
  //
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  
  //  デバッグログ出力(Hybridcast のコードを参考)
  mojIf.dbgLog = function( textIn ) {
    console.log( textIn );
//    dbgLog( textIn );
  }
  
  // consoleが使えない場合は空のオブジェクトを設定しておく (IE対策)
  if( typeof console === "undefined" ) {
    console = {};
  }
  
  // console.logがメソッドでない場合は空のメソッドを用意する (IE対策)
  if( typeof console.log !== "function" ) {
    console.log = function(){};
  }
  
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  //
  //  MOJ loaded notification callback
  //
  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////
  
} catch( e ) {
  mojIf.dbgLog( e.fileName + ":" + e.lineNumber + "\n" + e.message );
}
